/* 
 * File: MainController.js
 * Container controller for the entire world
 */

/*jslint node: true, vars: true, bitwise: true */
/*global angular, document, ClassExample */
/* find out more about jslint: http://www.jslint.com/help.html */

"use strict";

// Creates the "backend" logical support for appMyExample
var myModule = angular.module("appMyExample", ["CSS450Timer", "CSS450Slider", "CSS450Xform"]);

// registers the constructor for the controller
// NOTE: the constructor is only called _AFTER_ the </body> tag is encountered
//       this code does NOT run until the end of loading the HTML page
myModule.controller("MainCtrl", function ($scope) {
       // this is the model
    $scope.mMyWorld = new ClassExample('GLCanvas');
    
    $scope.mWorldObjects = [
        $scope.mMyWorld.mRedSq,
        $scope.mMyWorld.mBlueSq,
        $scope.mMyWorld.mTLSq,
        $scope.mMyWorld.mTRSq,
        $scope.mMyWorld.mBLSq,
        $scope.mMyWorld.mBRSq
    ];
    
    // Hacky interface to mMyWorld ...
    $scope.eSelection = [
        {index: "0", label: "Red"},
        {index: "1", label: "Blue"},
        {index: "2", label: "TopLeft"},
        {index: "3", label: "TopRight"},
        {index: "4", label: "BotLeft"},
        {index: "5", label: "BotRight"}
    ];
    $scope.mSelected = "0";

    $scope.redrawWorld = function () {
        $scope.mMyWorld.draw();
    };
    
    $scope.selectObject = function () {
        $scope.mSelectedLabel = $scope.eSelection[$scope.mSelected].label;
        $scope.mSelectedXform = $scope.mWorldObjects[$scope.mSelected].getXform();
    };
    
    
    // support for growing the red
    // suppor for growing the blue square
    $scope.mEnableGrow = true;
    $scope.mNeedRedraw = false;
    $scope.growTheRed = function () {
        $scope.mMyWorld.increaseRedSize();
        $scope.mMyWorld.draw();
        $scope.mNeedRedraw = true;
    };
        
    $scope.selectObject();
    $scope.mMyWorld.draw();
});