/* 
 * File: MainController.js
 * Container controller for the entire world
 */

/*jslint node: true, vars: true, bitwise: true */
/*global angular, document, ClassExample, vec2 */
/* find out more about jslint: http://www.jslint.com/help.html */

"use strict";

// Creates the "backend" logical support for appMyExample
var myModule = angular.module("appMyExample", ["CSS450Timer", "CSS450Slider", "CSS450Xform"]);

// registers the constructor for the controller
// NOTE: the constructor is only called _AFTER_ the </body> tag is encountered
//       this code does NOT run until the end of loading the HTML page
myModule.controller("MainCtrl", function ($scope) {
       // this is the model
    $scope.mMyWorld = new ClassExample('GLCanvas');
 
    // Cache these to support quick mouse event handling
    var canvas = document.getElementById('GLCanvas');
    $scope.mCanvasBounds = canvas.getBoundingClientRect();
    $scope.mCanvasWidth = canvas.width;
    $scope.mCanvasHeight = canvas.height;
    $scope.mCanvasBoundsTop = $scope.mCanvasBounds.top;
    $scope.mCanvasBoundsLeft = $scope.mCanvasBounds.left;
    $scope.mCanvasXRatio = $scope.mCanvasWidth / $scope.mCanvasBounds.width;
    $scope.mCanvasYRatio = $scope.mCanvasHeight / $scope.mCanvasBounds.height;
    $scope.mEventClientX = 0;
    $scope.mEventClientY = 0;

    $scope.redrawWorld = function () {
        $scope.mMyWorld.draw();
    };

    $scope.getPixelXPos = function (event) {
        return Math.round((event.clientX -  $scope.mCanvasBoundsLeft) * $scope.mCanvasXRatio);
    };
    $scope.getPixelYPos = function(event) {
        var y = Math.round((event.clientY -  $scope.mCanvasBoundsTop) * $scope.mCanvasYRatio);
        return ($scope.mCanvasHeight - 1 - y);
    };

    $scope.trackMouse = function (event) {
        $scope.mMouseX = $scope.getPixelXPos(event);
        $scope.mMouseY = $scope.getPixelYPos(event);

        $scope.mEventClientX = event.clientX;
        $scope.mEventClientY = event.clientY;
    };
    $scope.mMyWorld.draw();
});